/*----- PROTECTED REGION ID(MetadataImporterStateMachine.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        MetadataImporterStateMachine.cpp
//
// description : State machine file for the MetadataImporter class
//
// project :     Metadata importer device server
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <MetadataImporter.h>

/*----- PROTECTED REGION END -----*/	//	MetadataImporter::MetadataImporterStateMachine.cpp

//================================================================
//  States  |  Description
//================================================================
//  ON      |  Metadata importer is in ON state (connected to server and ready to import)
//  OFF     |  Metadata importer is in OFF state (not connected to server)
//  FAULT   |  Metadata importer is in FAULT state (not ready to import metadata)
//  ALARM   |  Metadata importer is in FAULT state (not ready to import metadata)


namespace MetadataImporter_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : MetadataImporter::is_TupleCounter_allowed()
 *	Description : Execution allowed for TupleCounter attribute
 */
//--------------------------------------------------------
bool MetadataImporter::is_TupleCounter_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for TupleCounter attribute in read access.
	/*----- PROTECTED REGION ID(MetadataImporter::TupleCounterStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	MetadataImporter::TupleCounterStateAllowed_READ
	return true;
}

//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method      : MetadataImporter::is_On_allowed()
 *	Description : Execution allowed for On attribute
 */
//--------------------------------------------------------
bool MetadataImporter::is_On_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::ON ||
		get_state()==Tango::FAULT ||
		get_state()==Tango::ALARM)
	{
	/*----- PROTECTED REGION ID(MetadataImporter::OnStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	MetadataImporter::OnStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : MetadataImporter::is_Off_allowed()
 *	Description : Execution allowed for Off attribute
 */
//--------------------------------------------------------
bool MetadataImporter::is_Off_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Compare device state with not allowed states.
	if (get_state()==Tango::OFF ||
		get_state()==Tango::FAULT)
	{
	/*----- PROTECTED REGION ID(MetadataImporter::OffStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	MetadataImporter::OffStateAllowed
		return false;
	}
	return true;
}

//--------------------------------------------------------
/**
 *	Method      : MetadataImporter::is_ResetCounter_allowed()
 *	Description : Execution allowed for ResetCounter attribute
 */
//--------------------------------------------------------
bool MetadataImporter::is_ResetCounter_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for ResetCounter command.
	/*----- PROTECTED REGION ID(MetadataImporter::ResetCounterStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	MetadataImporter::ResetCounterStateAllowed
	return true;
}

}	//	End of namespace
